using System;
using System.Collections;
using System.Drawing;
using System.Windows.Forms;
using System.ComponentModel;

namespace ReflectionIT.Windows.Forms
{
	#if NETCFDESIGNTIME
	[Designer(typeof(SpinButtonsDesigner))]
	[DefaultEvent("SpinDown")]
	#endif
	public class SpinButton : System.Windows.Forms.Control
	{

		#if NETCFDESIGNTIME
		[Category("Action")]
		#endif
		public event EventHandler SpinDown;

		#if NETCFDESIGNTIME
		[Category("Action")]
		#endif
		public event EventHandler SpinUp;

		private UpDownButton _buttonDown;
		private UpDownButton _buttonUp;


		public SpinButton()
		{
			// initialization after the InitForm call
			#if NETCFDESIGNTIME
				this.SetStyle(ControlStyles.AllPaintingInWmPaint, true);
				this.SetStyle(ControlStyles.DoubleBuffer, true);
				this.SetStyle(ControlStyles.UserPaint, true);
				this.SetStyle(ControlStyles.Selectable, false);
			#endif

			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}
		#region Component Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			_buttonUp = new UpDownButton();
			_buttonUp.Down = false;
			_buttonUp.Click += new EventHandler(buttonUp_Click);
			_buttonUp.Left = 0;
			_buttonUp.Top = 0;
			this.Controls.Add(_buttonUp);

			_buttonDown = new UpDownButton();
			_buttonDown.Down = true;
			_buttonDown.Click += new EventHandler(buttonDown_Click);
			_buttonDown.Left = 13;
			_buttonDown.Top = 0;
			this.Controls.Add(_buttonDown);

			this.Width = 27;
			this.Height = 20;
		}
		#endregion

		private void buttonUp_Click(object sender, System.EventArgs e) {
			if (SpinUp != null) {
				SpinUp(this, new EventArgs());
			}
		}

		private void buttonDown_Click(object sender, System.EventArgs e) {
			if (SpinDown != null) {
				SpinDown(this, new EventArgs());
			}
		}

		#if NETCFDESIGNTIME
		public new Size Size {        // make readonly
			get {
				return DefaultSize;
			}
		}

		//    The control will always keep its defaultsize, so the designer
		//    will not insert a 'new Size' line.
		protected override Size DefaultSize {
			get {
				return new Size (27,20);
			}
		}

		[
		Browsable(false), 
		EditorBrowsable(EditorBrowsableState.Never),
		DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)
		]
		public override string Text {
			get { return base.Text; }
			set { 
				// ignore 
			}
		}
		#endif

	}

}
